<div class="container">
    <div class="d-flex justify-content-end">
        <button mat-raised-button color="primary" class="control" *ngIf="state === actionStatus.view"
            (click)="state=actionStatus.edit">Edit</button>
        <button mat-raised-button color="accent" class="control" *ngIf="state === actionStatus.edit"
            (click)="state=actionStatus.view; discard()">Discard</button>
        <button mat-raised-button color="primary" class="control" *ngIf="state === actionStatus.edit"
            (click)="state=actionStatus.view; save()">Save</button>
        <button mat-raised-button color="primary" class="control" *ngIf="state === actionStatus.create"
            (click)="state=actionStatus.view; create()">Create</button>
    </div>
    <div class="row">
        <div class="col-lg-6">
            <img src="{{product.imageURL}}" class="product-image" *ngIf="state === actionStatus.view" />
            <img class="product-image edit" src="{{product.imageURL}}" *ngIf="state !== actionStatus.view"
                (click)="uploadImage()" />
        </div>
        <div class="col-lg-6">
            <div class="d-flex justify-content-between">
                <h3 *ngIf="state === actionStatus.view">{{product.name}}</h3>
                <mat-form-field *ngIf="state !== actionStatus.view">
                    <input matInput placeholder="English name" [(ngModel)]="product.name" name="name">
                </mat-form-field>
            </div>
            <div class="d-flex justify-content-between">
                <p *ngIf="state === actionStatus.view">${{product.price}} / {{product.unit}}</p>
                <mat-form-field *ngIf="state !== actionStatus.view">
                    <input matInput placeholder="Price" [(ngModel)]="product.price" name="price">
                </mat-form-field>
                <mat-form-field *ngIf="state !== actionStatus.view">
                    <mat-label>Unit</mat-label>
                    <mat-select [(ngModel)]="product.unit">
                        <mat-option *ngFor="let unit of units" [value]="unit">
                            {{unit}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
                <ngb-rating [(rate)]="product.star" max="5" [readonly]="state === actionStatus.view">
                    <ng-template let-fill="fill" let-index="index">
                        <span class="star" [class.filled]="fill === 100">&#9733;</span>
                    </ng-template>
                </ngb-rating>
            </div>
            <mat-divider></mat-divider>
            <span *ngIf="state === actionStatus.view">{{product.shortDescription}}</span>
            <mat-form-field [style.fontSize]="14" *ngIf="state !== actionStatus.view" class="input-fluid">
                <mat-label>Short description</mat-label>
                <textarea matInput cdkTextareaAutosize #autosize="cdkTextareaAutosize" cdkAutosizeMinRows="5"
                    cdkAutosizeMaxRows="20" [(ngModel)]="product.shortDescription" name="shortDescription"></textarea>
            </mat-form-field>
            <mat-divider></mat-divider>
            <div class="d-flex justify-content-start" style="margin: 8px;">
                <div class="quantity-control">
                    <button [disabled]="productQuantity === 1" (click)="productQuantity=productQuantity-1">-</button>
                    <input type="number" [(ngModel)]="productQuantity" name="quantity" class="quantity-field">
                    <button (click)="productQuantity=productQuantity+1">+</button>
                </div>
                <button mat-raised-button id="add-to-cart-button">Add to cart</button>
                <button mat-icon-button id="heart-button" aria-label="Example icon-button with a heart icon">
                    <mat-icon>favorite</mat-icon>
                </button>
            </div>
            <mat-divider></mat-divider>
            <p *ngIf="state === actionStatus.view">Category: {{product.category.name}}</p>
            <mat-form-field *ngIf="state !== actionStatus.view">
                <mat-label>Category</mat-label>
                <mat-select [(ngModel)]="product.categoryId">
                    <mat-option *ngFor="let category of categories" [value]="category.id">
                        {{category.name}}
                    </mat-option>
                </mat-select>
            </mat-form-field>
            <section>
                <mat-slide-toggle color="primary" [(ngModel)]="product.status" name="status"
                    [disabled]="state === actionStatus.view">
                    Status
                </mat-slide-toggle>
            </section>
        </div>
    </div>
    <mat-tab-group>
        <mat-tab label="Description">
            <span *ngIf="state === actionStatus.view">{{product.longDescription}}</span>
            <mat-form-field [style.fontSize]="14" *ngIf="state !== actionStatus.view" class="input-fluid">
                <mat-label>Long description</mat-label>
                <textarea matInput cdkTextareaAutosize #autosize="cdkTextareaAutosize" cdkAutosizeMinRows="1"
                    cdkAutosizeMaxRows="5" [(ngModel)]="product.longDescription" name="longDescription"></textarea>
            </mat-form-field>
        </mat-tab>
        <mat-tab label="Additional Info">
            <table class="table table-bordered" *ngIf="state === actionStatus.view">
                <tbody>
                    <tr>
                        <td>Calories</td>
                        <td>{{product.calories}} kcal</td>
                    </tr>
                    <tr>
                        <td>Carbohydrate</td>
                        <td>{{product.carbohydrate}} g</td>
                    </tr>
                    <tr>
                        <td>Fiber</td>
                        <td>{{product.fiber}} g</td>
                    </tr>
                    <tr>
                        <td>Sugar</td>
                        <td>{{product.sugar}} g</td>
                    </tr>
                    <tr>
                        <td>Fat</td>
                        <td>{{product.fat}} g</td>
                    </tr>
                    <tr>
                        <td>Protein</td>
                        <td>{{product.protein}} g</td>
                    </tr>
                </tbody>
            </table>
            <div class="edit-additional-info" *ngIf="state !== actionStatus.view">
                <div class="d-flex justify-content-between">
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Calories (kcal)" [(ngModel)]="product.calories"
                            name="calories">
                    </mat-form-field>
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Carbohydrate (g)" [(ngModel)]="product.carbohydrate"
                            name="carbohydrate">
                    </mat-form-field>
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Fiber (g)" [(ngModel)]="product.fiber" name="fiber">
                    </mat-form-field>
                </div>
                <div class="d-flex justify-content-between">
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Sugar (g)" [(ngModel)]="product.sugar" name="sugar">
                    </mat-form-field>
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Fat (g)" [(ngModel)]="product.fat" name="fat">
                    </mat-form-field>
                    <mat-form-field class="input-fluid">
                        <input matInput type="number" placeholder="Protein (g)" [(ngModel)]="product.protein"
                            name="protein">
                    </mat-form-field>
                </div>
            </div>
        </mat-tab>
        <mat-tab label="Compare"></mat-tab>
    </mat-tab-group>
</div>
